# -*- coding: utf-8 -*-
"""
Created on Tue Jul 10 11:58:23 2018

@author: cza,rm,zp
"""

import json
import time
import random
import  requests
from PIL import Image
from bs4 import BeautifulSoup
import matplotlib.pyplot as plt
from urllib.parse import unquote


class TL(object):
    def __init__(self):
        self.headers={
            'host':'kyfw.12306.cn',
            'User-Agent':'Mozilla/5.0(WindowsNT10.0;Win64;x64;rv:60.0)Gecko/20100101Firefox/60.0',
            'Accept':'application/json,text/javascript,*/*;q=0.01',
            'Accept-Language':'zh-CN,zh;q=0.8',
            'Accept-Encoding':'gzip,deflate,br',
            'Content-Type':'application/x-www-form-urlencoded;charset=UTF-8',
            'X-Requested-With':'XMLHttpRequest',
        }
        self.dict = {}
        self.url = "https://kyfw.12306.cn/otn/login/init"
        self.codeurl='https://kyfw.12306.cn/passport/captcha/captcha-check'#提交验证码
        self.loginurl='https://kyfw.12306.cn/passport/web/login'#提交用户密码
        self.imgurl="https://kyfw.12306.cn/passport/captcha/captcha-image?login_site=E&module=login&rand=sjrand&{}".format(random.random())#验证码图片
        self.infourl='https://kyfw.12306.cn/otn/modifyUser/initQueryUserInfo'#个人信息


    def getcookie(self,url,headers):
        self.session = requests.session()
        self.session.get(url, headers=headers)

    def getimage(self):
        self.getcookie(self.url, self.headers)
        # 验证码处理

        # 显示图片
        r = self.session.get(self.imgurl, headers=self.headers)
        name = 'img.jpg'
        with open(name, "wb") as code:
            code.write(r.content)

    def code(self,code):
        # print("开始获取验证码")
        #验证验证码
        code=code.replace('#1','45,50')
        code=code.replace('#2','110,50')
        code=code.replace('#3','180,50')
        code=code.replace('#4','250,50')
        code=code.replace('#5','45,110')
        code=code.replace('#6','110,110')
        code=code.replace('#7','180,110')
        code=code.replace('#8','250,110')
        code=code[:-1]
        # print("替换完毕")
        data={
        'answer':code,
        'login_site':'E',
        'rand':'sjrand',
        }

        #提交验证码
        response = self.session.post(self.codeurl,headers=self.headers,data=data,timeout=5)
        # print(len(response))
        try:
            dic=json.loads(response.text)
        except:
            return False
        # print(code)
        resultCode = dic['result_code']
        resultMsg = dic['result_message']
        #返回值 和数字
        print( resultMsg,resultCode )
        if resultCode!='4':
            return False,resultMsg
        else:
            return True,resultMsg
    
    def login(self,username,password):
        #提交用户名密码
        data={
                'username':username,
                'password':password,
                'appid':'otn',
        }
        response = self.session.post(self.loginurl,headers=self.headers,data=data,timeout=5)
        try:
            dic=json.loads(response.text)
        except:
            return "NetWorkError"
        resultCode = dic['result_code']
        resultMsg = dic['result_message']
        if str(resultCode) in ['1','5']:
            print(resultCode,resultMsg)
            return False, resultMsg
        else:
            print(resultCode, resultMsg)
            # return True,resultMsg

            # 第一次验证
        data = {
            "appid": "otn"
        }
        url = "https://kyfw.12306.cn/passport/web/auth/uamtk"
        response = self.session.post(url, headers=self.headers, data=data)
        if response.status_code == 200:
            result = json.loads(response.text)
            msg=result.get("result_message")
            print("第一次"+msg)
            newapptk = result.get("newapptk")

        # 第二次验证
        data = {
            "tk": newapptk
        }
        url = "https://kyfw.12306.cn/otn/uamauthclient"
        response = self.session.post(url, headers=self.headers, data=data)
        if response.status_code == 200:
            result = json.loads(response.text)
            msg,name=result.get("result_message"), result.get("username")
            print("第二次"+msg)

            # 确认信息
        url = "https://kyfw.12306.cn/otn/index/initMy12306"
        response = self.session.get(url, headers=self.headers)

        print(response.text.find("用户名"))

        if response.status_code == 200 :#and response.text.find("用户名") != -1:
            return True,"登录成功"
        msg="登陆失败"
        print(msg)
        return False, msg


    def Getsite(self):
        url='https://kyfw.12306.cn/otn/resources/js/framework/station_name.js?station_version=1.9058'
        response = requests.get(url,headers=self.headers,timeout=5)
        response.encoding="utf8"
        s=response.text.replace('var station_names =','')
        s=s[1:-2]
        s=s.split('@')
        for i in s:
            i=i.split('|')
            result=len(i)
            if result==6:
                self.dict[i[1]]=i[2]
        return self.dict


    def information(self):#个人信息
        info={}
        infourl='https://kyfw.12306.cn/otn/modifyUser/initQueryUserInfo'#个人信息
        data={
            '_json_att':''
        }
        response = self.session.post(infourl,headers=self.headers,data=data)
        soup=BeautifulSoup( response.text,"lxml")


        for i in range(3):
            div=soup.find('div',attrs={'class':'layout order'})
            div=div.find('div',attrs={'class':'lay-bd'})
            #三个分块
            ###第一块basic_info_view
            ##第二块relation_way_view
            ##第三块append_info_view
            if i==0:
                id='basic_info_view'
            elif i==1:
                id='relation_way_view'
            else:
                id='append_info_view'
            div=div.find('div',attrs={'id':id})
            divs=div.find_all('div',attrs={'class':'info-item'})
            for div in divs:
                result1=div.span.text
                result2=div.div.text
                info[result1.replace('*','')]=result2
                print(result1.replace('*',''),result2)
        return info

    def getLXR(self):#获取联系人
        url='https://kyfw.12306.cn/otn/passengers/init'
        data={
            '_json_att':'',
        }
        response=self.session.post(url,headers=self.headers,data=data)
        print("sdadasda")
        print(response)
        soup = BeautifulSoup(response.content,"html.parser")
        script=soup.find_all('script',attrs={'xml:space':'preserve'})[1]
        result=str(script).split('\n')[2].replace('var passengers=','').replace(';','')
        result=eval(result)#字符串转化为list
        list=[]
        for i in result:
            list.append(i['passenger_name'])
            # print(i['passenger_name'])
        return list


    def Inquire(self,fromstation,tostation,date):
        #查看列车信息
        result={}
        url='https://kyfw.12306.cn/otn/leftTicket/query?leftTicketDTO.train_date='+date+'&leftTicketDTO.from_station='+fromstation+'&leftTicketDTO.to_station='+tostation+'&purpose_codes=ADULT'
        response = requests.get(url,headers=self.headers,timeout=5)
        response.encoding="utf8"
        try:
            dic=json.loads(response.text)
        except:
            msg="请输入正确的时间和信息"
            # print( '转化字典出错' )
            return False,msg,result
        if('data' in dic.keys()):
            result= dic['data']['result']#列车信息
        else:
            msg=dic['messages'][0]
            return False,msg,result
        new_result = []

        for i in result:
            i = i.split('|')
            new_result.append(i)

        for index, value in enumerate(new_result):
            for a, b in enumerate(value):
                if b == '':
                    # print(a)
                    new_result[index][a] = '--'
                    # print(new_result)
            new_result = []

            for i in result:
                i = i.split('|')
                new_result.append(i)



        return True,new_result,result

    def Order(self, dicts, LCId, train_date, back_train_date, query_from_station_name,
              query_to_station_name, seatType, name):
        headers=self.headers
        secrestr = dicts[LCId][0]
        print(LCId, train_date, back_train_date, query_from_station_name, query_to_station_name,
              seatType, name)
        print(dicts)
        # 第一次请求  确认是否登陆
        data = {
            '_json_att': '',
        }
        url = 'https://kyfw.12306.cn/otn/login/checkUser'
        response = self.session.post(url, headers=headers, data=data, timeout=5)
        dic = json.loads(response.text)
        flg = dic['data']['flag']
        print(flg)
        if flg:
            # 第二次请求  发送列车信息
            url = 'https://kyfw.12306.cn/otn/leftTicket/submitOrderRequest'
            data = {
                'secretStr': secrestr,  # 列车标识
                'train_date': train_date,  # 出发时间
                'back_train_date': back_train_date,  # 返程时间
                'tour_flag': 'dc',  # 单程
                'purpose_codes': 'ADULT',
                'query_from_station_name': query_from_station_name,  # 出发地
                'query_to_station_name': query_to_station_name,  # 目的地
                'undefined': '',
            }
            response = self.session.post(url, headers=headers, data=data, timeout=5)
            dic = json.loads(response.text)
            status = dic['status']
            print(status)
            # {"validateMessagesShowId":"_validatorMessage","status":true,"httpstatus":200,"data":"N","messages":[],"validateMessages":{}}
            if status:
                data = {
                    '_json_att': '',
                }
                # 第三次请求输入乘客信息
                url = 'https://kyfw.12306.cn/otn/confirmPassenger/initDc'
                response = self.session.post(url, headers=headers, data=data, timeout=5)
                response.encoding = "utf8"
                # 对响应做处理得到globalRepeatSubmitToken，leftTicket,key_check_isChange
                result = response.text
                soup = BeautifulSoup(result, "lxml")
                x = soup.find('script')
                globalRepeatSubmitToken = str(x).split(';')[1].split('=')[1].replace("'", '')
                index = str(result).find('leftTicketStr') - 1
                leftTicket = str(result)[index:index + 100].split(',')[0].split(':')[1].replace("'", '')
                index = str(result).find('key_check_isChange') - 1
                key_check_isChange = str(result)[index:index + 100].split(',')[0].split(':')[1].replace("'", '')

                # 选择乘客
                url = 'https://kyfw.12306.cn/otn/confirmPassenger/getPassengerDTOs'
                response = self.session.get(url, headers=headers, timeout=5)
                response.encoding = "utf8"
                dic = json.loads(response.text)
                dic = dic['data']
                dic = dic['normal_passengers']
                for i in dic:
                    if i['passenger_name'] == name:
                        print('成功')
                        url = 'https://kyfw.12306.cn/otn/confirmPassenger/checkOrderInfo'
                        data = {
                            'cancel_flag': '2',
                            'bed_level_order_num': '000000000000000000000000000000',
                            'passengerTicketStr': str(seatType) + ',0,1,' + i['passenger_name'] + ',1,' + i[
                                'passenger_id_no'] + ',' + i['mobile_no'] + ',N',
                            'oldPassengerStr': i['passenger_name'] + ',1,' + i['passenger_id_no'] + ',' + i[
                                'passenger_type'] + '_',
                            'tour_flag': 'dc',
                            'randCode': '',
                            'whatsSelect': '1',
                            '_json_att': '',
                            'REPEAT_SUBMIT_TOKEN': globalRepeatSubmitToken,
                        }
                        response = self.session.post(url, headers=headers, data=data, timeout=5)
                        response.encoding = "utf8"
                        dic = json.loads(response.text)
                        dic = dic['data']
                        if dic['submitStatus']:
                            print('传输乘客信息成功')  # 商务座：9  二等座：O  一等座：M  硬卧：3 硬座：1  软卧：4  无座：1
                            url = 'https://kyfw.12306.cn/otn/confirmPassenger/getQueueCount'
                            times = ' '.join(time.ctime().split(' ')[:3])
                            data = {
                                'train_date': times + ' 2018 00:00:00 GMT+0800 (中国标准时间)',  # 火车时间
                                'train_no': dicts[LCId][1],  #
                                'stationTrainCode': dicts[LCId][2],  # 车次号
                                'seatType': str(seatType),  # 座位类型
                                'fromStationTelecode': dicts[LCId][3],
                                'toStationTelecode': dicts[LCId][4],
                                'leftTicket': leftTicket,
                                'purpose_codes': '00',  # 默认为成年人
                                'train_location': dicts[LCId][5],
                                '_json_att': '',
                                'REPEAT_SUBMIT_TOKEN': globalRepeatSubmitToken,
                            }
                            print(data)
                            response = self.session.post(url, headers=headers, data=data, timeout=5)
                            dic = json.loads(response.text)
                            status = dic['status']
                            if status:
                                print('传输车次信息成功')
                                time.sleep(random.randint(1, 5))
                                url = 'https://kyfw.12306.cn/otn/confirmPassenger/confirmSingleForQueue'
                                data = {
                                    '_json_att': '',
                                    'choose_seats': '',
                                    'dwAll': 'N',
                                    'key_check_isChange': key_check_isChange,
                                    'leftTicketStr': leftTicket,
                                    'passengerTicketStr': str(seatType) + ',0,1,' + i['passenger_name'] + ',1,' + i[
                                        'passenger_id_no'] + ',' + i['mobile_no'] + ',N',
                                    'oldPassengerStr': i['passenger_name'] + ',1,' + i['passenger_id_no'] + ',' + i[
                                        'passenger_type'] + '_',
                                    'purpose_codes': '00',
                                    'randCode': '',
                                    'REPEAT_SUBMIT_TOKEN': globalRepeatSubmitToken,
                                    'roomType': '00',
                                    'seatDetailType': '000',
                                    'train_location': dicts[LCId][5],
                                    'whatsSelect': '1',
                                }
                                response = self.session.post(url, headers=headers, data=data, timeout=5)
                                dic = json.loads(response.text)
                                status = dic['status']
                                if status:
                                    print('传输联系人成功')
                                    print(dic)
                                    if dic['data']['submitStatus']:
                                        print('确认信息成功')
                                        return "火车票购买成功，请到官网支付"
                                    else:
                                        # 进入订单队列 需要等待
                                        flag = True
                                        orderId = ''  # 订单号
                                        while flag:
                                            print('a')
                                            time.sleep(random.randint(1, 5))
                                            url = 'https://kyfw.12306.cn/otn/confirmPassenger/queryOrderWaitTime?random={}&tourFlag=dc&_json_att=&REPEAT_SUBMIT_TOKEN={}'.format(
                                                round(time.time() * 1000), globalRepeatSubmitToken)
                                            response = self.session.get(url, headers=headers)
                                            try:
                                                dic = json.loads(response.content)
                                            except:
                                                return "NetWorkError"
                                            print(dic)
                                            if dic['status']:
                                                if dic['data']['queryOrderWaitTimeStatus']:
                                                    if dic['data']['waitTime'] > 0:
                                                        return dic['data']['waitTime']
                                                    elif dic['data']['waitTime'] == -1:
                                                        orderId = dic['data']['orderId']
                                                        flag = False
                                                    else:
                                                        pass
                                                else:
                                                    pass
                                            else:
                                                pass
                                        #####################################
                                        time.sleep(random.randint(1, 5))
                                        url = 'https://kyfw.12306.cn/otn/confirmPassenger/resultOrderForDcQueue'
                                        data = {
                                            'orderSequence_no': orderId,
                                            '_json_att': '',
                                            'REPEAT_SUBMIT_TOKEN': globalRepeatSubmitToken,
                                        }
                                        response = self.session.post(url, headers=headers, data=data)
                                        try:
                                            dic = json.loads(response.content)
                                        except:
                                            return "NetWorkError"
                                        print(dic)
                                        if dic['data']['submitStatus']:
                                            print('确认信息成功')
                                            print('火车票购买成功，请到官网支付')
                                            print('你的订单号为：' + orderId)
                                            flag = False
                                        else:
                                            print(dic)
                                            print('失败', dic['data']['errMsg'])
                                            #                                            self.Order(headers,dicts,LCId,train_date,back_train_date,query_from_station_name,query_to_station_name,seatType)
                        break
                    else:
                        print('你输入的姓名有误')
            else:
                print('预定失败')
        else:
            return response.text


            
if __name__=='__main__':
    tl=TL()
    tl.Inquire("广州南","上海","2018-07-18")
    # tl.getimage()
    # a=input()
    # tl.code(a)
    # tl.login("13469170417","ZHUAN980630")

